"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.babelProjectPlugin = void 0;

var _tapable = require("tapable");

var _plugins = require("@sewing-kit/plugins");

var PLUGIN = 'SewingKit.babel';
var addBabelHooks = (0, _plugins.addHooks)(function () {
  return {
    babelConfig: new _tapable.AsyncSeriesWaterfallHook(['babelConfig']),
    babelIgnorePatterns: new _tapable.AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
  };
});
var babelProjectPlugin = (0, _plugins.createProjectPlugin)({
  id: PLUGIN,
  run: function run(_ref) {
    var build = _ref.build,
        test = _ref.test;
    build.tap(PLUGIN, function (_ref2) {
      var hooks = _ref2.hooks;
      hooks["package"].tap(PLUGIN, function (_ref3) {
        var hooks = _ref3.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.webApp.tap(PLUGIN, function (_ref4) {
        var hooks = _ref4.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.service.tap(PLUGIN, function (_ref5) {
        var hooks = _ref5.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
    test.tap(PLUGIN, function (_ref6) {
      var hooks = _ref6.hooks;
      hooks.project.tap(PLUGIN, function (_ref7) {
        var hooks = _ref7.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
  }
});
exports.babelProjectPlugin = babelProjectPlugin;