import { AsyncSeriesWaterfallHook } from 'tapable';
import { addHooks, createProjectPlugin } from '@sewing-kit/plugins';
var PLUGIN = 'SewingKit.babel';
var addBabelHooks = addHooks(function () {
  return {
    babelConfig: new AsyncSeriesWaterfallHook(['babelConfig']),
    babelIgnorePatterns: new AsyncSeriesWaterfallHook(['babelIgnorePatterns'])
  };
});
export var babelProjectPlugin = createProjectPlugin({
  id: PLUGIN,
  run: function run(_ref) {
    var build = _ref.build,
        test = _ref.test;
    build.tap(PLUGIN, function (_ref2) {
      var hooks = _ref2.hooks;
      hooks["package"].tap(PLUGIN, function (_ref3) {
        var hooks = _ref3.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.webApp.tap(PLUGIN, function (_ref4) {
        var hooks = _ref4.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
      hooks.service.tap(PLUGIN, function (_ref5) {
        var hooks = _ref5.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
    test.tap(PLUGIN, function (_ref6) {
      var hooks = _ref6.hooks;
      hooks.project.tap(PLUGIN, function (_ref7) {
        var hooks = _ref7.hooks;
        hooks.configure.tap(PLUGIN, addBabelHooks);
      });
    });
  }
});